/*global $ */
"use strict";
$.restart = function() {
    return $.ajax({
            type: 'POST',
            url: '/stereo/restart',
            success: function(){
                console.log("Successfully restarted");
            },
            error: function(){
                console.log("Restart failed");
            }
    });
};

$.waitForApp = function(callback, minimum_wait, reference_time) {
    $("#overlay").show();
    var deferred = $.Deferred();
    if ( minimum_wait == undefined ) {
        minimum_wait = 2000;
    }
    var pollTimer, timeoutTimer;
    setTimeout(function() {
        var timer = 0;
        function pollStarted() {
            // Wait for the application to finish restarting
            $.ajax("/stereo/startup_time", {
                cache: false,
                success: function (data) {
                    if (data && data > reference_time) {
                        clearTimeout(timeoutTimer);
                        if (callback) callback();
                        deferred.resolve();
                    } else {
                        pollTimer = setTimeout(pollStarted, 2000);
                    }
                }, error: function() {
                    pollTimer = setTimeout(pollStarted, 2000);
                }
            });
        }
        pollStarted();
    }, minimum_wait);
    $("#overlay").show();
    timeoutTimer = setTimeout(function() {
        clearTimeout(pollTimer);
        deferred.reject();
        alert("The application does not seem to start. Redirecting to application menu.");
        window.location = "/admin/devtools.shtml";
    }, 200000);
    return deferred;
};

$.restartAndWait = function(callback) {
    var d_response = $.Deferred();
    $.when($.getStartTime()).done(function(ref_start_time){
        $.when($.restart(),$.waitForApp(callback, 5000, ref_start_time)).done(function() {
            d_response.resolve();
        });
    });
    return d_response;

};

$.getStartTime = function(){
    // Fetch reference startup_time
    return $.ajax("/stereo/startup_time", {
        cache: false,
        success: function (data) {
            // Nothing to do here as we are sure a correct timestamp is returned from backend
        }, error: function() {
            if(confirm("The application does not seem to start. Try again in a few minutes by clicking \"cancel\" or go to the application menu by clicking \"ok\".")){
                window.location = "/admin/devtools.shtml";
            }
        }
    });
}

$(function () {
    $(".ctrlHolder input, .ctrlHolder select, .ctrlHolder .ui-slider-handle").on("focus", function () {
        $(this).parents(".ctrlHolder:first").addClass("focused");
    }).on("blur", function () {
        $(this).parents(".ctrlHolder:first").removeClass("focused");
    });
    $(".helpIcon").each(function () {
        var $icon = $(this),
            $text = $("#" + $icon.attr("for"));
        $icon.click(function () {
            if ($icon.hasClass("active")) {
                $text.slideUp();
                $icon.removeClass("active").removeClass("stick-active");
            } else {
                $text.slideDown().css("display", "inline-block");
                $icon.addClass("active").addClass("stick-active");
            }
        });
    });
    $(".flash").each(function () {
        var $flash = $(this);
        setTimeout(function () {
            $flash.slideUp();
        }, 5000);
    });
    $.fn.addLoader = function (type,  skip_disable) {
        var $element = $(this[0]),
            loader_src,
            $loader;
        if (typeof skip_disable === "undefined") {
            skip_disable = false;
        }
        if (type === "light") {
            loader_src = "/static/image/ajax-loader-light.gif";
        } else {
            //Default
            loader_src = "/static/image/ajax-loader.gif";
        }
        $loader = $("<div/>")
                .addClass("loaderWrapper")
                .append(
                $("<img/>")
                    .attr("src", loader_src)
                    .addClass("loader")
            );
        $element.append($loader);
        if (!skip_disable) {
            this.prop("disabled", true);
        }
        return this;
    };
    $.fn.removeLoader = function () {
        var $element = $(this[0]);
        $element.find(".loaderWrapper").remove();
        this.prop("disabled", false);
        return this;
    };
    var now = new Date(TIMETUPLE[0], TIMETUPLE[1] - 1, TIMETUPLE[2], TIMETUPLE[3], TIMETUPLE[4], TIMETUPLE[5]);
    $('#theclockbar').clockbar(now);
});
