"use strict"
$.fn.timezone = function(){
    var timezones = [];

    // Copy over the values from the real dropdown list
    $("#validation-wrapper-timezone option").each(function(){
        timezones.push($(this).val());
    });

    /*
     * Create the autocomplete search field and add the copied list.
     * On change set the changed value to be active in the real dropdown.
     */
    $("#validation-wrapper-timezone").append("<input placeholder='Type region or timezone city'></input>");
    $("#validation-wrapper-timezone input").autocomplete({
        source: timezones,
        minLength: 0,
        change: function(event, ui) {
            $("#timezone").val(ui.item.value);
        }
    });

    // Disable form submit on enter press from this input
    $("#validation-wrapper-timezone input").keydown(function(event){
        if(event.keyCode == 13){
            return false;
        }
    });

    // Add on focus show all options
    $("#validation-wrapper-timezone input").on("click", function(){
        $(this).autocomplete("search", "");
    });

    // Set the previously saved item to be displayed in the autocomplete search field if found
    var savedValue = $("#timezone").find(":selected").text();
    if(savedValue.length !== 0){
        $("#validation-wrapper-timezone input").val(savedValue);
    }

    // Hide the real dropdown to still handle save and load
    $("#timezone").hide();

    // Add scroll css properties to the created search field
    $("#ui-id-15").css({"overflow-y": "auto", "overflow-x": "hidden", "max-height": "350px"});
};
